#!/usr/bin/perl -w
#Markus Westphal 13.01.2006

######################################################
#            Markus Westphal  swomim.pl              #
######################################################
use strict;
my($pf,$j,$i,$stand,$datei,@ind,$search,$record,$ind,$id,$cc,$dr,@mims,$aus,$aus2,@tics,$ti,$cs,$tr,$m,$row,$omi,$borat,$rock);

#globale Variabeln fllen
$datei = "sp-out1.txt";
$i = 0;
$rock = 0;
$row = 0;

#EINLESEN Dateinamen 
for($j = -1; $j < $#ARGV; $j++)
{
   if($ARGV[$j] =~ /^datei/)
   {
       ($pf, $datei) = split("=", $ARGV[$j]);
   }
}
print "AUSGABEDATEI...\n";
#AUSGABEDATEI
open(HF, ">omimaus.htm") || die ("Die Ausgabedatei kann nicht erstellt werden!\n");
     print HF '<p><b><font size="4" face="Verdana">Auswertung:</font></b></p>';
     print HF '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">';
     print HF "<html><head><title>SwOMIM - Markus Westphal - FH Gieen-Friedberg</title>";
     print HF "</head><body>";
     print HF "<table border=\"1\" width=\"100%\" style=\"border-collapse: collapse\" bordercolor=\"#000000\">";
     print HF '<tr><td align="center"><b><font face="Verdana">ID</font></b></td><td align="center"><b><font face="Verdana">CC</font></b></td><td align="center"><b><font face="Verdana">DR</font></b></td><td align="center"><b><font face="Verdana">OMIM</font></b></td></tr>';
print "EINLESEN...\n";
#EINLESEN
open(SW,"<$datei") || die ("$datei kann nicht geoeffnet werden!");

$/ = "/-0-/";
while(<SW>)
{
#print "RECORD\n";
  $record = $_;
  #print "$record\n";
  if($record =~ /DR/m)
  {
   #print"DRIN\n";
   $record =~ /ID\s+(.*AA)\.\nCC\s+(-!-\s+.*)CC\s+\-+\nDR\s+(.*)\n.*/s;
   $id = $1;
   $cc = $2;
   $dr = $3;
   $cc =~ s/CC//g;$cc =~ s/  //g; $cc =~ s/\n//g;
   $dr =~ s/DR//g;$dr =~ s/  //g; $dr =~ s/\n//g;
   if($dr =~ /MIM; /m)
   {
    #print "DRIN\n";
    @mims = split("MIM;",$dr);
    $m = 0;
    $row = 0;
    $tr = "";
    foreach(@mims) #Array mit den ganzen OMIM Nummern die in EINEM Eintrag gefunden werden
    {
     if($_ =~ /^ (\d+);/) # rausnehmen von den Teilen, die keine sind
     {
      #print "LINK\n";
      if($m > 0){$tr = "<tr>\n";} #Beim ersten Mal  muss ein <tr> da stehen
      $aus = &ParseOmim($1); # Aufruf zum Suchen des Eintrags in der Omim
      ($aus,$aus2) = split("##",$aus); #TI und CS Rckgabe in einer Variabel dann gesplittet
      # TI und CS mit Html-Formatierung
      $tics[$m] = $tr.'<td valign="top"><font face="Verdana"><b>'.$aus.'</b></font></td></tr><tr><td valign="top"><font face="Verdana">'.$cs.'</font></td></tr>';
      $m++; #Zhler fr $tics[]
      $row = $row+2; # Fr jeden Eintrag Rowspan + 2
      $tr = ""; # Jetzt muss kein tr am Anfang mehr stehen also leer machen
     }
    }
   #Ausgabe einer ganzen Zeile. Rowspan von oben. Die Punkte sind nur wegen ' da sonst muss man stndig / schreiben
   print HF '<tr><td rowspan="'.$row.'" valign="top">'.$id.'</td><td rowspan="'.$row.'" valign="top">'.$cc.'</td><td rowspan="'.$row.'" valign="top">'.$dr.'</td>';
   foreach(@tics)
   {
    print HF "$_"; # Hier werden dann alle Teile mit TI und CS ausgegeben von oben
   }
   undef(@tics);
   undef(@mims);
   print HF "</tr>\n";
   print "EINTAG ERSTELLT\n";
   }
  }
  $rock++;
  $/ = "/-$rock-/";
}
close(SW);

print HF "</table>\n</body>\n</html>\n";
close(HF);
print "FERTIG!\n";

#OMIM-Funktionen
sub ParseOmim()
{
 my($z) = @_; #gesuchte MIM ID
 print "$z\n";
  $omi = "E:\\gendatenbanken\\swissprot\\omim\\omim.txt";
  open(OM, "<$omi") || die ("$omi kann nicht gelesen werden!\n");
  $/ = "*RECORD*";
  while(<OM>)
  {
   if($_ =~ m/\*FIELD\* NO\n$z/m)
   {
     $borat = $_;
     last;
   }
  }
  close(OM);

#RegExp fr TI CS
  if($borat =~ /\*FIELD\* CS/m)
  {
    $borat =~ /.*\*FIELD\* TI\n(.*)\*FIELD\* TX.*\*FIELD\* CS\n(.*)\*FIELD\* .*\*RECORD\*/s;
    $ti = $1;
    $cs = $2;
  }
  else
  {
    $borat =~ /.*\*FIELD\* TI\n(.*)\*FIELD\* TX.*/s;
    $ti = $1;
    $cs = "NICHT VORHANDEN!";
  }
  $ti =~ s/\n//g || print "$borat\n";
  $ti = "TI: ".$ti;
  $cs = "CS: ".$cs;
  $ti = $ti."###".$cs;
  return $ti;
}
