#!/usr/bin/perl -w
#Markus Westphal 14.11.2006

######################################################
#            Markus Westphal BlastParser             #
######################################################
use strict;
#use CGI::Carp qw(fatalsToBrowser);

my($sort,$letters, $color, @idnetz, @hilf, @aus,$zaus, $first, %ausgabe, $aberg, $q, $sb, $s, $qs, $qe, $ss, $se, $h, $ht, $htm, $html, $j, $id, $de,$dego, $deanh, $acc, $score, $dt, $datei, $ids, $start, $length, $evalue, $gaps, $gapp, $gappp, $i, $idnet, $posit);
#Einlesen aus Browserbergabe
#$ENV{'QUERY_STRING'} =~ s/sl=alle//g;
#$ENV{'QUERY_STRING'} =~ s/ol=alle//g;
#$ENV{'QUERY_STRING'} =~ s/%3A/,/g;
#$ENV{'QUERY_STRING'} =~ s/%3B/;/g;
#$ENV{'QUERY_STRING'} =~ s/+/\ \/g;
#@ARGV = split("&",$ENV{'QUERY_STRING'});

#print HF "Content-type: text/html\n\n";

#globale Variabeln fllen
$zaus = 0;
$evalue = 0;
$s = 0;
$letters = 0;
$sort = 0;
$dt = 0;
$dego = 0;
$start = 0;
$html = 0;
$qs = 0;
$length = 0;
$aberg = 0;
$gaps = 0;
$gapp = 0;
$first = 1;
$sort = 0;
#Einlesen
for($j = -1; $j < $#ARGV; $j++)
{
   if($ARGV[$j] =~ /^datei/)
   {
       ($dt, $datei) = split("=", $ARGV[$j]);
   }
   if($ARGV[$j] =~ /^html/)
   {
       ($ht, $htm) = split("=", $ARGV[$j]);
       if($htm eq "on")
       {
          $html = 1;
       }
   }
   if($ARGV[$j] =~ /^sort/)
   {
       ($ht, $htm) = split("=", $ARGV[$j]);
       if($htm eq "ab")
       {
          $sort = 1;
       }
   }
}
#HTML-Header
if($html == 1)
{
 open(HF, ">ergebnisblast.htm") || die ("Die Ausgabedatei kann nicht erstellt werden!\n");
     print HF '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">';
     print HF "<html><head><title>Blastparser - Markus Westphal - FH Gieen-Friedberg</title>\n";
     print HF "</head><body>\n";
     print HF '<p><b><font size="3" face="Verdana">Blastparse</font></b></p>';
}
else
{
 open(TF, ">ergebnisblast.txt") || die ("Die Ausgabedatei kann nicht erstellt werden!\n");
 print TF "BLASTPARSE\n";
}
#keine Datei
if($dt eq "0")
{
  print TF "FEHLER: Keine Eingabedatei!";
  if($html == 1)
  {
    print HF "<font color=red><br>KEIN DATEI ANGEGEBEN!!!\n";
  }
die ("Lesevorgang abgebrochen!\n");
}

open(F, "<$datei") || die ("$datei kann nicht gelesen werden!\n");
my($vor,$nach);
$vor = 1;
$nach = 0;
while(<F>)
{
 $i++;
        if(index($_,"letters)") > -1)
        {
         $_ =~ /\((\d*) letters\)/;
         $letters = $1;
        }
        if(index($_,"Length =") > -1)
        {
          $_ =~ s/Length = //gi;
          $_ =~ s/ //g;
          chomp($_);
          $dego = 0;
          #$length = $_;
          #$aberg = (31*($length**-0.124) + 3 * 18.2 * ($length**-0.305));
        }
        if($dego == 1)
        {
          $de .= $_;
          $de =~ s/           //g;
          chomp($de);
        }
        if($_ =~ /^>/)
        {
         if($first == 0)
         {
          &Merken();
         }
          $_ =~ />+(\w*) +(\w*) +(.*)/;
          $id = $1;
          $acc = $2;
          $de = $3;
          chomp($de);
          $dego = 1;
          $s = 0;
        }
        if(index($_ ,"Score") > -1)
        {
        #Alles ausgeben
         if($s == 1 && $first == 0)
         {
          &Merken();
         }
          $s = 1;
          $_ =~ /(\w*), Expect = +(\S*)/;
          $evalue = $2;
          $first = 0;
        }
        if(index($_,"Identities =") > -1)
        {
          @idnetz = split(",",$_);
          $idnetz[0] =~ / Identities = (\d*)\/(.*)\((\d*)%\)/;#ndern 2.Wert
          $length = $2;
          $idnet = $3;
          $idnetz[1] =~ / Positives = (\d*)\/.* \((\d*)%\)/;
          $posit = $2;
          $gaps = 0;
          $gapp = 0;
           if($#idnetz >= 2)
           {
            $idnetz[2] =~ / Gaps = (\d*)\/.* \((\d*)%\)/;
            $gaps = $1;
            $gapp = $2;
           }
          #print "$idnet\n";
          $q = 0;
          $sb = 0;
        }
        if(index($_,"Query: ") > -1)
        {
          if($q == 0)
          {
           $_ =~ /Query: (\d*) +(.*) (\d*)/;
           $qs = $1;
           $q = 1;
          }
          else
          {
           $_ =~ /Query: (\d*) +(.*) (\d*)/;
           $qe = $3;
          }
        }
        if(index($_,"Sbjct: ") > -1)
        {
          if($sb == 0)
          {
           $_ =~ /Sbjct: (\d*) +(.*) (\d*)/;
           $ss = $1;
           $sb = 1;
          }
          else
          {
           $_ =~ /Sbjct: (\w*) +(.*) (\w*)/;
           $se = $3;
          }
        }
}
close (F);

#Nochmal fr die letzten Werte!
&Merken();
&Ausgabe();
#Funktionen
sub Merken()
{
my($merker,$farber,$farbere,$color);
if($length > 0)
{
$aberg = (31*($length**-0.124) + 3 * 18.2 * ($length**-0.305));
$aberg = $idnet-$aberg;
 if($html == 1)
 {
  $farber = "<font face=\"Arial\">$aberg</font>";
  $farbere = "<font face=\"Arial\">$evalue</font>";
  $color = 'bgcolor="#FFFFFF"';
   if($aberg > 0 && $evalue > (1e-3))
   {
     $farber = "<font face=\"Arial\" ><b>$aberg</b></font>";
     $farbere = "<font face=\"Arial\"><b>$evalue</b></font>";
     $color = 'bgcolor="#00FF00"';
   }
       $merker = "<tr>
       <td align=left valign=top $color><font face=\"Arial\">$id</font></td>
       <td align=left valign=\"top\" $color><font face=\"Arial\">$acc</font></td>
       <td align=left valign=\"top\" $color><font face=\"Arial\">$letters</font></td>
       <td align=left valign=\"top\" $color><font face=\"Arial\">$length</font></td>
       <td align=left valign=\"top\" $color>$farbere</td>
       <td align=left valign=\"top\" $color>$farber</td>
       <td align=center valign=\"top\" $color><font face=\"Arial\">$idnet%</font></td>
       <td align=center valign=\"top\" $color><font face=\"Arial\">$posit%</font></td>
       <td align=left valign=\"top\" $color><font face=\"Arial\">$gaps</font></td>
       <td align=center valign=\"top\" $color><font face=\"Arial\">$gapp%</font></td>
       <td align=left valign=\"top\" $color><font face=\"Arial\">$qs</font></td>
       <td align=left valign=\"top\" $color><font face=\"Arial\">$qe</font></td>
       <td align=left valign=\"top\" $color><font face=\"Arial\">$ss</font></td>
       <td align=left valign=\"top\" $color><font face=\"Arial\">$se</font></td>
       <td align=left valign=\"top\" $color><font face=\"Arial\">$de</font></td>
       </tr>";
  }
  else
  {
    $aberg =~ /(.+\.\d{4}).+/;
    $merker = "$id\t\t$acc\t\t$letters\t\t$length\t\t$1\t\t\t$evalue\t\t$idnet\t$posit\t$gaps\t$gapp\t$qs\t$qe\t$ss\t$s\t$de";
  }
     if($sort == 1)
     {
        if(defined $ausgabe{$aberg})
        {
           $aberg = $aberg + 0.0000001;
        }
        $ausgabe{$aberg} = $merker;
     }
     else { $aus[$zaus]= $merker; $zaus++;}
}

sub Ausgabe()
{
my($index, $zeile);

if($html == 1)
{
  print HF '<table border="1" cellpadding="3" cellspacing="2" style="border-collapse: collapse" bordercolor="#111111" width="100%" id="AutoNumber1">';
  print HF "<tr>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>ID</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>ACC</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>QLEN</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>HLEN</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>EVALUE</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>ABAGYAN</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>IDENTITIES</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>POSITIVES</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>GAPS</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>GAPP</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>QBEG</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>QEND</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>HBEG</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>HEND</b></font></th>
       <th align=left valign=\"top\"><font face=\"Verdana\"><b>DE</b></font></th>
       </tr>";
}
  if($sort == 1)
  {
  @hilf = sort {$a<=>$b} keys %ausgabe;
   foreach (@hilf)
   {
     if($html == 1)
     {
       print HF "$ausgabe{$_}\n";
     }
     else
     {
      print TF "$ausgabe{$_}\n";
     }
   }
  }
  else
  {
    foreach (@aus)
    {
     if($html == 1)
     {
      print HF "$_\n";
     }
     else
     {
      print TF "$_\n";
     }
    }
  }
  if($html == 1)
  {
     print HF "</table>";
     print HF "</body></html>\n";
   close (HF);
  }
}
}
